/*
 * Copyright 2018-2020 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

FUNC void restoreFlexRAM(void)
{
    unsigned int value;
    unsigned int base;

    base = 0x400AC000;

    value = _RDWORD(base + 0x44);
    value &= ~(0xFFFF);
    value |= 0x5FA5;
    _WDWORD(base + 0x44, value);

    value = _RDWORD(base + 0x40);
    value |= (1 << 2);
    _WDWORD(base + 0x40, value);
}

FUNC void Setup (void) {
  SP = _RDWORD(0x60002000);          // Setup Stack Pointer
  PC = _RDWORD(0x60002004);          // Setup Program Counter
  _WDWORD(0xE000ED08, 0x60002000);   // Setup Vector Table Offset Register
}

FUNC void OnResetExec (void)  {      // executes upon software RESET
  restoreFlexRAM();
  Setup();                           // Setup for Running
}

restoreFlexRAM();

LOAD %L INCREMENTAL                  // Download

Setup();                             // Setup for Running

// g, main
